module comsaison_h

implicit none

  real,save :: dist_sol ! Sun-Mars distance (AU)
  real,save :: declin ! declination (rad)
  real,save :: zls ! solar longitude (rad)
  real,save,allocatable :: mu0(:) ! cosine of solar zenith angle
  real,save,allocatable :: fract(:) ! day fraction over the time interval (0: night, 1: day)
  real,save,allocatable :: local_time(:) ! local solar time as fraction of day (0,1)

!$OMP THREADPRIVATE(dist_sol,declin,zls,mu0,fract,local_time)

contains

  subroutine ini_comsaison_h(ngrid)
  
  implicit none
  integer,intent(in) :: ngrid ! number of atmospheric columns
  
    allocate(mu0(ngrid))
    allocate(fract(ngrid))
    allocate(local_time(ngrid))
  
  end subroutine ini_comsaison_h


  subroutine end_comsaison_h

  implicit none

    if (allocated(mu0)) deallocate(mu0)
    if (allocated(fract)) deallocate(fract)
    if (allocated(local_time)) deallocate(local_time)

  end subroutine end_comsaison_h
  
end module comsaison_h
